Index: trunk/source/processes/hadronic/models/de_excitation/gem_evaporation/src/G4F19GEMProbability.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/gem_evaporation/src/G4F19GEMProbability.cc	(revision 1055)
+++ trunk/source/processes/hadronic/models/de_excitation/gem_evaporation/src/G4F19GEMProbability.cc	(revision 1196)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4F19GEMProbability.cc,v 1.5 2006/06/29 20:22:01 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4F19GEMProbability.cc,v 1.6 2009/09/15 12:54:17 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // Hadronic Process: Nuclear De-excitations
Index: trunk/source/processes/hadronic/models/de_excitation/gem_evaporation/src/G4F20GEMProbability.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/gem_evaporation/src/G4F20GEMProbability.cc	(revision 1055)
+++ trunk/source/processes/hadronic/models/de_excitation/gem_evaporation/src/G4F20GEMProbability.cc	(revision 1196)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4F20GEMProbability.cc,v 1.5 2006/06/29 20:22:03 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4F20GEMProbability.cc,v 1.6 2009/09/15 12:54:17 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // Hadronic Process: Nuclear De-excitations
Index: trunk/source/processes/hadronic/models/de_excitation/gem_evaporation/src/G4F21GEMProbability.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/gem_evaporation/src/G4F21GEMProbability.cc	(revision 1055)
+++ trunk/source/processes/hadronic/models/de_excitation/gem_evaporation/src/G4F21GEMProbability.cc	(revision 1196)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4F21GEMProbability.cc,v 1.4 2006/06/29 20:22:05 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4F21GEMProbability.cc,v 1.5 2009/09/15 12:54:17 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // Hadronic Process: Nuclear De-excitations
Index: trunk/source/processes/hadronic/models/de_excitation/gem_evaporation/src/G4GEMChannel.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/gem_evaporation/src/G4GEMChannel.cc	(revision 1055)
+++ trunk/source/processes/hadronic/models/de_excitation/gem_evaporation/src/G4GEMChannel.cc	(revision 1196)
@@ -25,10 +25,16 @@
 //
 //
-// $Id: G4GEMChannel.cc,v 1.7 2009/03/12 11:25:28 ahoward Exp $
-// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+// $Id: G4GEMChannel.cc,v 1.10 2009/10/08 07:55:39 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // Hadronic Process: Nuclear De-excitations
 // by V. Lara (Oct 1998)
 //
+// J. M. Quesada (September 2009) bugs fixed in  probability distribution for kinetic 
+//              energy sampling:
+//  		-hbarc instead of hbar_Planck (BIG BUG)
+//              -quantities for initial nucleus and residual are calculated separately
+// V.Ivanchenko (September 2009) Added proper protection for unphysical final state 
+// J. M. Quesada (October 2009) fixed bug in CoulombBarrier calculation 
 
 #include "G4GEMChannel.hh"
@@ -65,27 +71,8 @@
 }
 
-G4GEMChannel::G4GEMChannel(const G4int theA, const G4int theZ, const G4String * aName,
-                           G4GEMProbability * aEmissionStrategy,
-                           G4VCoulombBarrier * aCoulombBarrier) :
-  G4VEvaporationChannel(aName),
-  A(theA),
-  Z(theZ),
-  theEvaporationProbabilityPtr(aEmissionStrategy),
-  theCoulombBarrierPtr(aCoulombBarrier),
-  EmissionProbability(0.0),
-  MaximalKineticEnergy(-1000.0)
-{ 
-  theLevelDensityPtr = new G4EvaporationLevelDensityParameter;
-  MyOwnLevelDensity = true;
-}
-
-
 G4GEMChannel::~G4GEMChannel()
 {
     if (MyOwnLevelDensity) delete theLevelDensityPtr;
 }
-
-
-
 
 G4GEMChannel::G4GEMChannel(const G4GEMChannel & ) : G4VEvaporationChannel()
@@ -112,51 +99,56 @@
 }
 
-
-
 void G4GEMChannel::Initialize(const G4Fragment & fragment)
 {
-
-    G4int anA = static_cast<G4int>(fragment.GetA());
-    G4int aZ = static_cast<G4int>(fragment.GetZ());
-    AResidual = anA - A;
-    ZResidual = aZ - Z;
-    
-    // Effective excitation energy
-    //    G4double ExEnergy = fragment.GetExcitationEnergy() -
-    //      G4PairingCorrection::GetInstance()->GetPairingCorrection(anA,aZ);
-//090120
-    //G4double ExEnergy = fragment.GetExcitationEnergy() -
-      //G4PairingCorrection::GetInstance()->GetPairingCorrection(AResidual,ZResidual);
-    G4double ExEnergy = fragment.GetExcitationEnergy(); 
-    if ( AResidual > 0 ) ExEnergy -= G4PairingCorrection::GetInstance()->GetPairingCorrection(AResidual,ZResidual);
-//090120
-    
-    // We only take into account channels which are physically allowed
-    if (AResidual <= 0 || ZResidual <= 0 || AResidual < ZResidual ||
-        (AResidual == ZResidual && AResidual > 1) || ExEnergy <= 0.0) 
-      {
-        CoulombBarrier = 0.0;
-        MaximalKineticEnergy = -1000.0*MeV;
-        EmissionProbability = 0.0;
-      } 
-    else 
-      {
+  G4int anA = static_cast<G4int>(fragment.GetA());
+  G4int aZ = static_cast<G4int>(fragment.GetZ());
+  AResidual = anA - A;
+  ZResidual = aZ - Z;
+  //G4cout << "G4GEMChannel::Initialize: Z= " << aZ << " A= " << anA
+  //	   << " Zres= " << ZResidual << " Ares= " << AResidual << G4endl; 
+
+  // We only take into account channels which are physically allowed
+  if (AResidual <= 0 || ZResidual <= 0 || AResidual < ZResidual ||
+      (AResidual == ZResidual && AResidual > 1)) 
+    {
+      CoulombBarrier = 0.0;
+      MaximalKineticEnergy = -1000.0*MeV;
+      EmissionProbability = 0.0;
+    } 
+  else 
+    {
+
+      // Effective excitation energy
+      // JMQ 071009: pairing in ExEnergy should be the one of parent compound nucleus 
+      // FIXED the bug causing reported crash by VI (negative Probabilities 
+      // due to inconsistency in Coulomb barrier calculation (CoulombBarrier and -Beta 
+      // param for protons must be the same)   
+      //    G4double ExEnergy = fragment.GetExcitationEnergy() -
+      //    G4PairingCorrection::GetInstance()->GetPairingCorrection(AResidual,ZResidual);
+      G4double ExEnergy = fragment.GetExcitationEnergy() -
+	G4PairingCorrection::GetInstance()->GetPairingCorrection(anA,aZ);
+
+      //G4cout << "Eexc(MeV)= " << ExEnergy/MeV << G4endl;
+
+      if( ExEnergy <= 0.0) {
+	CoulombBarrier = 0.0;
+	MaximalKineticEnergy = -1000.0*MeV;
+	EmissionProbability = 0.0;
+
+      } else {
+
         // Coulomb Barrier calculation
-        CoulombBarrier = theCoulombBarrierPtr->GetCoulombBarrier(AResidual,ZResidual,ExEnergy);
-
-//  	std::cout << "\tfragment (" << A << ',' << Z << ") residual (" << AResidual << ',' << ZResidual << ')'; 
-//  	std::cout << " U = " << fragment.GetExcitationEnergy();
-//  	std::cout << " delta = " << G4PairingCorrection::GetInstance()->GetPairingCorrection(anA,aZ);
-//  	std::cout << " U-delta = " << ExEnergy;
-//  	std::cout << " V = " << CoulombBarrier;
-        
-        // Maximal Kinetic Energy
-        MaximalKineticEnergy = CalcMaximalKineticEnergy(G4ParticleTable::GetParticleTable()->
-                                                        GetIonTable()->GetNucleusMass(aZ,anA)+ExEnergy);
-
-//  	std::cout << " Tmax-V = " << MaximalKineticEnergy << '\n';
+	CoulombBarrier = theCoulombBarrierPtr->GetCoulombBarrier(AResidual,ZResidual,ExEnergy);
+	//G4cout << "CBarrier(MeV)= " << CoulombBarrier/MeV << G4endl;
+
+	//Maximal kinetic energy (JMQ : at the Coulomb barrier)
+	MaximalKineticEnergy = 
+	  CalcMaximalKineticEnergy(G4ParticleTable::GetParticleTable()->
+				   GetIonTable()->GetNucleusMass(aZ,anA)+ExEnergy);
+	//G4cout << "MaxE(MeV)= " << MaximalKineticEnergy/MeV << G4endl;
+
 		
-        // Emission probability
-        if (MaximalKineticEnergy <= 0.0) 
+	// Emission probability
+	if (MaximalKineticEnergy <= 0.0) 
 	  {
 	    EmissionProbability = 0.0;
@@ -165,18 +157,20 @@
 	  { 
 	    // Total emission probability for this channel
-	    EmissionProbability = theEvaporationProbabilityPtr->EmissionProbability(fragment,MaximalKineticEnergy);
+	    EmissionProbability = 
+	      theEvaporationProbabilityPtr->EmissionProbability(fragment,MaximalKineticEnergy);
 	  }
       }
-    
+    }
+   
+    //G4cout << "Prob= " << EmissionProbability << G4endl;
     return;
 }
 
-
 G4FragmentVector * G4GEMChannel::BreakUp(const G4Fragment & theNucleus)
 {
-    
     G4double EvaporatedKineticEnergy = CalcKineticEnergy(theNucleus);
     G4double EvaporatedMass = G4ParticleTable::GetParticleTable()->GetIonTable()->GetIonMass(Z,A);
     G4double EvaporatedEnergy = EvaporatedKineticEnergy + EvaporatedMass;
+
     
     G4ThreeVector momentum(IsotropicVector(std::sqrt(EvaporatedKineticEnergy*
@@ -187,5 +181,4 @@
     G4LorentzVector EvaporatedMomentum(momentum,EvaporatedEnergy);
     EvaporatedMomentum.boost(theNucleus.GetMomentum().boostVector());
-    
     G4Fragment * EvaporatedFragment = new G4Fragment(A,Z,EvaporatedMomentum);
 #ifdef PRECOMPOUND_TEST
@@ -238,16 +231,17 @@
 
 G4double G4GEMChannel::CalcMaximalKineticEnergy(const G4double NucleusTotalE)
-    // Calculate maximal kinetic energy that can be carried by fragment.
-{
-    G4double ResidualMass = G4ParticleTable::GetParticleTable()->
-        GetIonTable()->GetNucleusMass( ZResidual, AResidual );
-    G4double EvaporatedMass = G4ParticleTable::GetParticleTable()->
-        GetIonTable()->GetNucleusMass( Z, A );
-	
-    G4double T = (NucleusTotalE*NucleusTotalE + EvaporatedMass*EvaporatedMass - ResidualMass*ResidualMass)/
-        (2.0*NucleusTotalE) -
-        EvaporatedMass - CoulombBarrier;
-	
-    return T;
+// Calculate maximal kinetic energy that can be carried by fragment.
+//JMQ this is not the assimptotic kinetic energy but the one at the Coulomb barrier
+{
+  G4double ResidualMass = G4ParticleTable::GetParticleTable()->
+    GetIonTable()->GetNucleusMass( ZResidual, AResidual );
+  G4double EvaporatedMass = G4ParticleTable::GetParticleTable()->
+    GetIonTable()->GetNucleusMass( Z, A );
+	
+  G4double T = (NucleusTotalE*NucleusTotalE + EvaporatedMass*EvaporatedMass - ResidualMass*ResidualMass)/
+    (2.0*NucleusTotalE) -
+    EvaporatedMass - CoulombBarrier;
+	
+  return T;
 }
 
@@ -256,66 +250,88 @@
 
 G4double G4GEMChannel::CalcKineticEnergy(const G4Fragment & fragment)
-    // Samples fragment kinetic energy.
-{
-    G4double U = fragment.GetExcitationEnergy();
-	
-    G4double NuclearMass = G4ParticleTable::GetParticleTable()->GetIonTable()->GetNucleusMass(Z,A);
-
-    G4double a = theLevelDensityPtr->LevelDensityParameter(static_cast<G4int>(fragment.GetA()),
-							   static_cast<G4int>(fragment.GetZ()),U);
-//090115
-//G4double delta0 = G4PairingCorrection::GetInstance()->GetPairingCorrection(static_cast<G4int>(fragment.GetA()),
-//								       static_cast<G4int>(fragment.GetZ()));
-    G4double delta0 = G4PairingCorrection::GetInstance()->GetPairingCorrection(AResidual,ZResidual);
-//090115
-    
-    G4double Alpha = theEvaporationProbabilityPtr->CalcAlphaParam(fragment);
-    G4double Beta = theEvaporationProbabilityPtr->CalcBetaParam(fragment);
-    G4double Normalization = theEvaporationProbabilityPtr->GetNormalization();
-    
-    G4double Ux = (2.5 + 150.0/AResidual)*MeV;
-    G4double Ex = Ux + delta0;
-    G4double T = 1.0/(std::sqrt(a/Ux) - 1.5/Ux);
-    G4double E0 = Ex - T*(std::log(T*MeV) - std::log(a/MeV)/4.0 - 1.25*std::log(Ux*MeV) + 2.0*std::sqrt(a*Ux));
-
-    G4double InitialLevelDensity;
-    if ( U < Ex ) 
+// Samples fragment kinetic energy.
+{
+  G4double U = fragment.GetExcitationEnergy();
+  G4double NuclearMass = G4ParticleTable::GetParticleTable()->GetIonTable()->GetNucleusMass(Z,A);
+  
+  G4double Alpha = theEvaporationProbabilityPtr->CalcAlphaParam(fragment);
+  G4double Beta = theEvaporationProbabilityPtr->CalcBetaParam(fragment);
+
+  G4double Normalization = theEvaporationProbabilityPtr->GetNormalization();
+
+//                       ***RESIDUAL***
+  //JMQ (September 2009) the following quantities  refer to the RESIDUAL:
+  G4double delta0 = G4PairingCorrection::GetInstance()->GetPairingCorrection(AResidual,ZResidual);
+  G4double Ux = (2.5 + 150.0/AResidual)*MeV;
+  G4double Ex = Ux + delta0;
+  G4double InitialLevelDensity;
+  //                    ***end RESIDUAL ***
+  
+  //                       ***PARENT***
+  //JMQ (September 2009) the following quantities   refer to the PARENT:
+  
+  G4double deltaCN = G4PairingCorrection::GetInstance()->GetPairingCorrection(static_cast<G4int>(fragment.GetA()),
+									      static_cast<G4int>(fragment.GetZ()));
+  G4double aCN = theLevelDensityPtr->LevelDensityParameter(static_cast<G4int>(fragment.GetA()),
+							   static_cast<G4int>(fragment.GetZ()),U-deltaCN);   
+  G4double UxCN = (2.5 + 150.0/fragment.GetA())*MeV;
+  G4double ExCN = UxCN + deltaCN;
+  G4double TCN = 1.0/(std::sqrt(aCN/UxCN) - 1.5/UxCN);
+  G4double E0CN = ExCN - TCN*(std::log(TCN/MeV) - std::log(aCN*MeV)/4.0 - 1.25*std::log(UxCN/MeV) + 2.0*std::sqrt(aCN*UxCN));
+  //                       ***end PARENT***
+  
+  //JMQ quantities calculated for  CN in InitialLevelDensity
+  if ( U < ExCN ) 
+    {
+      InitialLevelDensity = (pi/12.0)*std::exp((U-E0CN)/TCN)/TCN;
+    } 
+  else 
+    {
+      InitialLevelDensity = (pi/12.0)*std::exp(2*std::sqrt(aCN*(U-deltaCN)))/std::pow(aCN*std::pow(U-deltaCN,5.0),1.0/4.0);
+    }
+  
+  const G4double Spin = theEvaporationProbabilityPtr->GetSpin();
+//JMQ  BIG BUG fixed: hbarc instead of hbar_Planck !!!!
+//     it was fixed in total probability (for this channel) but remained still here!!
+//    G4double g = (2.0*Spin+1.0)*NuclearMass/(pi2* hbar_Planck*hbar_Planck);
+    G4double g = (2.0*Spin+1.0)*NuclearMass/(pi2* hbarc*hbarc);
+//
+//JMQ  fix on Rb and  geometrical cross sections according to Furihata's paper 
+//                      (JAERI-Data/Code 2001-105, p6)
+  G4double Rb = 0.0; 
+    if (A > 4) 
+    {
+      G4double Ad = std::pow(G4double(fragment.GetA()-A),1.0/3.0);
+      G4double Aj = std::pow(G4double(A),1.0/3.0);
+      Rb = 1.12*(Aj + Ad) - 0.86*((Aj+Ad)/(Aj*Ad))+2.85;
+      Rb *= fermi;
+    }
+    else if (A>1)
       {
-        InitialLevelDensity = (pi/12.0)*std::exp((U-E0)/T)/T;
-      } 
+	//	G4double R1 = std::pow(G4double(fragment.GetA()-A),1.0/3.0);
+	//	G4double R2 = std::pow(G4double(A),1.0/3.0);
+      G4double Ad = std::pow(G4double(fragment.GetA()-A),1.0/3.0);
+      G4double Aj = std::pow(G4double(A),1.0/3.0);
+      //	RN = 1.12*(R1 + R2) - 0.86*((R1+R2)/(R1*R2));
+      Rb=1.5*(Aj+Ad)*fermi;
+    }
     else 
-      {
-        InitialLevelDensity = (pi/12.0)*std::exp(2*std::sqrt(a*(U-delta0)))/std::pow(a*std::pow(U-delta0,5.0),1.0/4.0);
-      }
-
-    const G4double Spin = theEvaporationProbabilityPtr->GetSpin();
-    G4double g = (2.0*Spin+1.0)*NuclearMass/(pi2* hbar_Planck*hbar_Planck);
-    G4double RN = 0.0;
-    if (A > 4) 
-    {
-	G4double R1 = std::pow(G4double(fragment.GetA()-A),1.0/3.0);
-	G4double R2 = std::pow(G4double(A),1.0/3.0);
-	RN = 1.12*(R1 + R2) - 0.86*((R1+R2)/(R1*R2));
-	RN *= fermi;
-    }
-    else 
-    {
-	RN = 1.5*fermi;
-    }
-    G4double GeometricalXS = pi*RN*RN*std::pow(G4double(fragment.GetA()-A),2./3.); 
+    {
+      G4double Ad = std::pow(G4double(fragment.GetA()-A),1.0/3.0);
+      //	RN = 1.5*fermi;
+      Rb = 1.5*Ad*fermi;
+    }
+    //   G4double GeometricalXS = pi*RN*RN*std::pow(G4double(fragment.GetA()-A),2./3.); 
+    G4double GeometricalXS = pi*Rb*Rb; 
     
 
     G4double ConstantFactor = g*GeometricalXS*Alpha/InitialLevelDensity;
     ConstantFactor *= pi/12.0;
+    //JMQ : this is the assimptotic maximal kinetic energy of the ejectile 
+    //      (obtained by energy-momentum conservation). 
+    //      In general smaller than U-theSeparationEnergy 
     G4double theEnergy = MaximalKineticEnergy + CoulombBarrier;
     G4double KineticEnergy;
     G4double Probability;
-
-//      std::cout << "\t\tEjectile (" << A << ',' << Z << ") V = " << CoulombBarrier 
-//  	      << " Beta = " << Beta << " V+Beta = " << CoulombBarrier+Beta << '\n';
-
-//G4cout << AResidual << " " << ZResidual << " " << ConstantFactor << " " << Beta << " " << CoulombBarrier << " " << MaximalKineticEnergy << " " << CoulombBarrier + MaximalKineticEnergy + Beta << G4endl;
-//090128
-if ( CoulombBarrier + MaximalKineticEnergy + Beta <= 0 ) return 0; 
 
     do 
@@ -323,4 +339,9 @@
         KineticEnergy =  CoulombBarrier + G4UniformRand()*MaximalKineticEnergy;
         Probability = ConstantFactor*(KineticEnergy + Beta);
+	G4double a = theLevelDensityPtr->LevelDensityParameter(AResidual,ZResidual,theEnergy-KineticEnergy-delta0);
+	G4double T = 1.0/(std::sqrt(a/Ux) - 1.5/Ux);
+	//JMQ fix in units
+	G4double E0 = Ex - T*(std::log(T/MeV) - std::log(a*MeV)/4.0 - 1.25*std::log(Ux/MeV) + 2.0*std::sqrt(a*Ux));
+	
         if ( theEnergy-KineticEnergy < Ex) 
 	  {
@@ -333,9 +354,6 @@
 	  }
         Probability /= Normalization;
-    }
+      }
     while (G4UniformRand() > Probability);
-
-
-    //  ---------------------------------------------------------------------------------------------------
     
     return KineticEnergy;
Index: trunk/source/processes/hadronic/models/de_excitation/gem_evaporation/src/G4GEMCoulombBarrierHE.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/gem_evaporation/src/G4GEMCoulombBarrierHE.cc	(revision 1055)
+++ trunk/source/processes/hadronic/models/de_excitation/gem_evaporation/src/G4GEMCoulombBarrierHE.cc	(revision 1196)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4GEMCoulombBarrierHE.cc,v 1.6 2006/06/29 20:22:09 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4GEMCoulombBarrierHE.cc,v 1.7 2009/09/15 12:54:17 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // Hadronic Process: Nuclear De-excitations
Index: trunk/source/processes/hadronic/models/de_excitation/gem_evaporation/src/G4GEMProbability.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/gem_evaporation/src/G4GEMProbability.cc	(revision 1055)
+++ trunk/source/processes/hadronic/models/de_excitation/gem_evaporation/src/G4GEMProbability.cc	(revision 1196)
@@ -29,5 +29,10 @@
 // by V. Lara (Sept 2001)
 //
-
+// J. M. Quesada : several fixes in total GEM width 
+// J. M. Quesada 14/07/2009 bug fixed in total emission width (hbarc)
+// J. M. Quesada (September 2009) several fixes:
+//       -level density parameter of residual calculated at its right excitation energy.
+//       -InitialLeveldensity calculated according to the right conditions of the 
+//        initial excited nucleus.
 
 #include "G4GEMProbability.hh"
@@ -65,31 +70,31 @@
                                                const G4double MaximalKineticEnergy)
 {
-    G4double EmissionProbability = 0.0;
+  G4double EmissionProbability = 0.0;
     
-    if (MaximalKineticEnergy > 0.0 && fragment.GetExcitationEnergy() > 0.0) {
-        G4double CoulombBarrier = GetCoulombBarrier(fragment);
-        
-        EmissionProbability = CalcProbability(fragment,MaximalKineticEnergy,CoulombBarrier);
-        Normalization = EmissionProbability;
-        // Next there is a loop over excited states for this channel summing probabilities
-        if (ExcitationEnergies  &&  ExcitationSpins && ExcitationLifetimes) {
-            G4double SavedSpin = Spin;
-            for (unsigned int i = 0; i < ExcitationEnergies->size(); i++) {
-                Spin = ExcitationSpins->operator[](i);
-                // substract excitation energies
-                G4double Tmax = MaximalKineticEnergy - ExcitationEnergies->operator[](i);
-                if (Tmax > 0.0) {
-                    G4double width = CalcProbability(fragment,Tmax,CoulombBarrier);
-                    // update probability
-                    if (hbar_Planck*std::log(2.0)/width < ExcitationLifetimes->operator[](i)) {
-                        EmissionProbability += width;
-                    }
-                }
-            }
-            // Restore Spin
-            Spin = SavedSpin;
-        }
-    }
-    return EmissionProbability;
+  if (MaximalKineticEnergy > 0.0 && fragment.GetExcitationEnergy() > 0.0) {
+    G4double CoulombBarrier = GetCoulombBarrier(fragment);
+      
+    EmissionProbability = CalcProbability(fragment,MaximalKineticEnergy,CoulombBarrier);
+    Normalization = EmissionProbability;
+    // Next there is a loop over excited states for this channel summing probabilities
+    if (ExcitationEnergies  &&  ExcitationSpins && ExcitationLifetimes) {
+      G4double SavedSpin = Spin;
+      for (unsigned int i = 0; i < ExcitationEnergies->size(); i++) {
+	Spin = ExcitationSpins->operator[](i);
+	// substract excitation energies
+	G4double Tmax = MaximalKineticEnergy - ExcitationEnergies->operator[](i);
+	if (Tmax > 0.0) {
+	  G4double width = CalcProbability(fragment,Tmax,CoulombBarrier);
+	  // update probability
+	  if (hbar_Planck*std::log(2.0)/width < ExcitationLifetimes->operator[](i)) {
+	    EmissionProbability += width;
+	  }
+	}
+      }
+      // Restore Spin
+      Spin = SavedSpin;
+    }
+  }
+  return EmissionProbability;
 }
 
@@ -97,70 +102,120 @@
                                            const G4double MaximalKineticEnergy,
                                            const G4double V)
-    // Calculate integrated probability (width) for evaporation channel
-{
-    G4double ResidualA = static_cast<G4double>(fragment.GetA() - theA);
-    //    G4double ResidualZ = static_cast<G4double>(fragment.GetZ() - theZ);
-    G4double U = fragment.GetExcitationEnergy();
-	
-    G4double NuclearMass = G4ParticleTable::GetParticleTable()->
-        GetIonTable()->GetNucleusMass(theZ,theA);
-
-    G4double a = theEvapLDPptr->LevelDensityParameter(static_cast<G4int>(fragment.GetA()),
-						      static_cast<G4int>(fragment.GetZ()),U);
-//090115
-//G4double delta0 = G4PairingCorrection::GetInstance()->GetPairingCorrection(static_cast<G4int>(fragment.GetA()),
-//								       static_cast<G4int>(fragment.GetZ()));
-    G4double ResidualZ = static_cast<G4double>(fragment.GetZ() - theZ);
-    G4double delta0 = G4PairingCorrection::GetInstance()->GetPairingCorrection( static_cast<G4int>( ResidualA ) , static_cast<G4int>( ResidualZ ) );
-//090115
-    
-    G4double Alpha = CalcAlphaParam(fragment);
-    G4double Beta = CalcBetaParam(fragment);
-    
-    
-    G4double Ux = (2.5 + 150.0/ResidualA)*MeV;
-    G4double Ex = Ux + delta0;
-    G4double T = 1.0/(std::sqrt(a/Ux) - 1.5/Ux);
-    G4double E0 = Ex - T*(std::log(T*MeV) - std::log(a/MeV)/4.0 - 1.25*std::log(Ux*MeV) + 2.0*std::sqrt(a*Ux));
-    
-    G4double Width;
-    G4double InitialLevelDensity;
-    if ( MaximalKineticEnergy < Ex ) {
-        G4double t = MaximalKineticEnergy/T;
-        Width = (I1(t,t) + (Beta+V)*I0(t))/std::exp(E0/T);
-        InitialLevelDensity = (pi/12.0)*std::exp((U-E0)/T)/T;
-    } else {
-        G4double t = MaximalKineticEnergy/T;
-        G4double tx = Ex/T;
-        G4double s = 2.0*std::sqrt(a*(MaximalKineticEnergy-delta0));
-        G4double sx = 2.0*std::sqrt(a*(Ex-delta0));
-        Width = I1(t,tx)/std::exp(E0/T) + I3(s,sx)*std::exp(s)/(std::sqrt(2.0)*a);
-        // For charged particles (Beta+V) = 0 beacuse Beta = -V
-        if (theZ == 0) {
-            Width += (Beta+V)*(I0(tx)/std::exp(E0/T) + 2.0*std::sqrt(2.0)*I2(s,sx)*std::exp(s));
-        }
-        InitialLevelDensity = (pi/12.0)*std::exp(2*std::sqrt(a*(U-delta0)))/std::pow(a*std::pow(U-delta0,5.0),1.0/4.0);
-    }
-    
-
-    G4double g = (2.0*Spin+1.0)*NuclearMass/(pi2* hbar_Planck*hbar_Planck);
-
-    G4double RN = 0.0;
-    if (theA > 4) 
+// Calculate integrated probability (width) for evaporation channel
+{
+  G4double ResidualA = static_cast<G4double>(fragment.GetA() - theA);
+  G4double ResidualZ = static_cast<G4double>(fragment.GetZ() - theZ);
+  G4double U = fragment.GetExcitationEnergy();
+  
+  G4double NuclearMass = G4ParticleTable::GetParticleTable()->
+    GetIonTable()->GetNucleusMass(theZ,theA);
+  
+  
+  G4double Alpha = CalcAlphaParam(fragment);
+  G4double Beta = CalcBetaParam(fragment);
+  
+  
+  //                       ***RESIDUAL***
+  //JMQ (September 2009) the following quantities refer to the RESIDUAL:
+  
+  G4double delta0 = G4PairingCorrection::GetInstance()->GetPairingCorrection( static_cast<G4int>( ResidualA ) , static_cast<G4int>( ResidualZ ) );  
+  
+  G4double a = theEvapLDPptr->LevelDensityParameter(static_cast<G4int>(ResidualA),
+  						    static_cast<G4int>(ResidualZ),MaximalKineticEnergy+V-delta0);
+  G4double Ux = (2.5 + 150.0/ResidualA)*MeV;
+  G4double Ex = Ux + delta0;
+  G4double T = 1.0/(std::sqrt(a/Ux) - 1.5/Ux);
+  //JMQ fixed bug in units
+  G4double E0 = Ex - T*(std::log(T/MeV) - std::log(a*MeV)/4.0 - 1.25*std::log(Ux/MeV) + 2.0*std::sqrt(a*Ux));
+  //                      ***end RESIDUAL ***
+  
+  //                       ***PARENT***
+  //JMQ (September 2009) the following quantities refer to the PARENT:
+     
+  G4double deltaCN=G4PairingCorrection::GetInstance()->
+    GetPairingCorrection(static_cast<G4int>(fragment.GetA()),static_cast<G4int>(fragment.GetZ()));				       
+  G4double aCN = theEvapLDPptr->LevelDensityParameter(static_cast<G4int>(fragment.GetA()),
+						      static_cast<G4int>(fragment.GetZ()),U-deltaCN);
+  G4double UxCN = (2.5 + 150.0/fragment.GetA())*MeV;
+  G4double ExCN = UxCN + deltaCN;
+  G4double TCN = 1.0/(std::sqrt(aCN/UxCN) - 1.5/UxCN);
+  //JMQ fixed bug in units
+  G4double E0CN = ExCN - TCN*(std::log(TCN/MeV) - std::log(aCN*MeV)/4.0 - 1.25*std::log(UxCN/MeV) + 2.0*std::sqrt(aCN*UxCN));
+//                       ***end PARENT***
+
+  G4double Width;
+  G4double InitialLevelDensity;
+  G4double t = MaximalKineticEnergy/T;
+  if ( MaximalKineticEnergy < Ex ) {
+    //JMQ 190709 bug in I1 fixed (T was  missing)
+    Width = (I1(t,t)*T + (Beta+V)*I0(t))/std::exp(E0/T);
+//JMQ 160909 fix:  InitialLevelDensity has been taken away (different conditions for initial CN..) 
+  } else {
+    G4double tx = Ex/T;
+    G4double s = 2.0*std::sqrt(a*(MaximalKineticEnergy-delta0));
+    G4double sx = 2.0*std::sqrt(a*(Ex-delta0));
+    Width = I1(t,tx)*T/std::exp(E0/T) + I3(s,sx)*std::exp(s)/(std::sqrt(2.0)*a);
+    // For charged particles (Beta+V) = 0 beacuse Beta = -V
+    if (theZ == 0) {
+      Width += (Beta+V)*(I0(tx)/std::exp(E0/T) + 2.0*std::sqrt(2.0)*I2(s,sx)*std::exp(s));
+    }
+  }
+  
+  //JMQ 14/07/2009 BIG BUG : NuclearMass is in MeV => hbarc instead of hbar_planck must be used
+  //    G4double g = (2.0*Spin+1.0)*NuclearMass/(pi2* hbar_Planck*hbar_Planck);
+  G4double g = (2.0*Spin+1.0)*NuclearMass/(pi2* hbarc*hbarc);
+  
+  //JMQ 190709 fix on Rb and  geometrical cross sections according to Furihata's paper 
+  //                      (JAERI-Data/Code 2001-105, p6)
+  //    G4double RN = 0.0;
+  G4double Rb = 0.0;
+  if (theA > 4) 
     {
-	G4double R1 = std::pow(ResidualA,1.0/3.0);
-	G4double R2 = std::pow(G4double(theA),1.0/3.0);
-	RN = 1.12*(R1 + R2) - 0.86*((R1+R2)/(R1*R2));
-	RN *= fermi;
-    }
+      //	G4double R1 = std::pow(ResidualA,1.0/3.0);
+      //	G4double R2 = std::pow(G4double(theA),1.0/3.0);
+      G4double Ad = std::pow(ResidualA,1.0/3.0);
+      G4double Aj = std::pow(G4double(theA),1.0/3.0);
+      //	RN = 1.12*(R1 + R2) - 0.86*((R1+R2)/(R1*R2));
+      Rb = 1.12*(Aj + Ad) - 0.86*((Aj+Ad)/(Aj*Ad))+2.85;
+      Rb *= fermi;
+    }
+  else if (theA>1)
+    {
+      G4double Ad = std::pow(ResidualA,1.0/3.0);
+      G4double Aj = std::pow(G4double(theA),1.0/3.0);
+      Rb=1.5*(Aj+Ad)*fermi;
+    }
+  else
+    {
+      G4double Ad = std::pow(ResidualA,1.0/3.0);
+      Rb = 1.5*Ad*fermi;
+    }
+  //   G4double GeometricalXS = pi*RN*RN*std::pow(ResidualA,2./3.); 
+  G4double GeometricalXS = pi*Rb*Rb; 
+  //end of JMQ fix on Rb by 190709
+  
+
+
+//JMQ 160909 fix: initial level density must be calculated according to the 
+// conditions at the initial compound nucleus 
+// (it has been removed from previous "if" for the residual) 
+
+   if ( U < ExCN ) 
+      {
+        InitialLevelDensity = (pi/12.0)*std::exp((U-E0CN)/TCN)/TCN;
+      } 
     else 
-    {
-	RN = 1.5*fermi;
-    }
-    G4double GeometricalXS = pi*RN*RN*std::pow(ResidualA,2./3.); 
-
-
-    Width *= std::sqrt(pi)*g*GeometricalXS*Alpha/(12.0*InitialLevelDensity); 
-    return Width;
+      {
+        InitialLevelDensity = (pi/12.0)*std::exp(2*std::sqrt(aCN*(U-deltaCN)))/std::pow(aCN*std::pow(U-deltaCN,5.0),1.0/4.0);
+      }
+ //
+
+
+  //JMQ 190709 BUG : pi instead of sqrt(pi) must be here according to Furihata's report:
+  //    Width *= std::sqrt(pi)*g*GeometricalXS*Alpha/(12.0*InitialLevelDensity); 
+  Width *= pi*g*GeometricalXS*Alpha/(12.0*InitialLevelDensity); 
+   
+
+  return Width;
 }
 
@@ -170,14 +225,14 @@
 G4double G4GEMProbability::I0(const G4double t)
 {
-    G4double result = (std::exp(t) - 1.0);
-    return result;
+  G4double result = (std::exp(t) - 1.0);
+  return result;
 }
 
 G4double G4GEMProbability::I1(const G4double t, const G4double tx)
 {
-    G4double result = t - tx + 1.0;
-    result *= std::exp(tx);
-    result -= (t + 1.0);
-    return result;
+  G4double result = t - tx + 1.0;
+  result *= std::exp(tx);
+  result -= (t + 1.0);
+  return result;
 }
 
@@ -185,32 +240,32 @@
 G4double G4GEMProbability::I2(const G4double s, const G4double sx)
 {
-    G4double S = 1.0/std::sqrt(s);
-    G4double Sx = 1.0/std::sqrt(sx);
-    
-    G4double p1 = S*S*S*( 1.0 + S*S*( 1.5 + 3.75*S*S) );
-    G4double p2 = Sx*Sx*Sx*( 1.0 + Sx*Sx*( 1.5 + 3.75*Sx*Sx) )*std::exp(sx-s);
-    
-    return p1-p2;
+  G4double S = 1.0/std::sqrt(s);
+  G4double Sx = 1.0/std::sqrt(sx);
+  
+  G4double p1 = S*S*S*( 1.0 + S*S*( 1.5 + 3.75*S*S) );
+  G4double p2 = Sx*Sx*Sx*( 1.0 + Sx*Sx*( 1.5 + 3.75*Sx*Sx) )*std::exp(sx-s);
+  
+  return p1-p2;
 }
 
 G4double G4GEMProbability::I3(const G4double s, const G4double sx)
 {
-    G4double s2 = s*s;
-    G4double sx2 = sx*sx;
-    G4double S = 1.0/std::sqrt(s);
-    G4double S2 = S*S;
-    G4double Sx = 1.0/std::sqrt(sx);
-    G4double Sx2 = Sx*Sx;
-    
-    G4double p1 = S *(2.0 + S2 *( 4.0 + S2 *( 13.5 + S2 *( 60.0 + S2 * 325.125 ))));
-    G4double p2 = Sx*Sx2 *(
-        (s2-sx2) + Sx2 *(
-            (1.5*s2+0.5*sx2) + Sx2 *(
-                (3.75*s2+0.25*sx2) + Sx2 *(
-                    (12.875*s2+0.625*sx2) + Sx2 *(
-                        (59.0625*s2+0.9375*sx2) + Sx2 *(324.8*s2+3.28*sx2))))));
-
+  G4double s2 = s*s;
+  G4double sx2 = sx*sx;
+  G4double S = 1.0/std::sqrt(s);
+  G4double S2 = S*S;
+  G4double Sx = 1.0/std::sqrt(sx);
+  G4double Sx2 = Sx*Sx;
+  
+  G4double p1 = S *(2.0 + S2 *( 4.0 + S2 *( 13.5 + S2 *( 60.0 + S2 * 325.125 ))));
+  G4double p2 = Sx*Sx2 *(
+			 (s2-sx2) + Sx2 *(
+					  (1.5*s2+0.5*sx2) + Sx2 *(
+								   (3.75*s2+0.25*sx2) + Sx2 *(
+											      (12.875*s2+0.625*sx2) + Sx2 *(
+															    (59.0625*s2+0.9375*sx2) + Sx2 *(324.8*s2+3.28*sx2))))));
+  
   p2 *= std::exp(sx-s);
-
+  
   return p1-p2; 
 }
Index: trunk/source/processes/hadronic/models/de_excitation/gem_evaporation/src/G4He3GEMChannel.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/gem_evaporation/src/G4He3GEMChannel.cc	(revision 1055)
+++ trunk/source/processes/hadronic/models/de_excitation/gem_evaporation/src/G4He3GEMChannel.cc	(revision 1196)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4He3GEMChannel.cc,v 1.4 2006/06/29 20:22:13 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4He3GEMChannel.cc,v 1.5 2009/09/15 12:54:17 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // Hadronic Process: Nuclear De-excitations
